<template>
    <div>
        <template v-if='confirmed'>
            <Alert type='success'>
                Честито! Ти официално си част от Тайния Дядо Коледа за 2022 година! На <strong>19 Ноември в 13:00</strong> ще получиш мейл, който ще те напомни да влезеш тук, за да видиш кой е <strong>Твоят Човек</strong>!
            </Alert>
        </template>
        <template v-else>
            <Alert type='warning'>
                {{ user.name }}, твоят профил все още не е потвърден. Това означава, че в момента <strong>не участваш</strong> в размяната на подаръци! Провери информацията по-долу и потвърждавай по-бързо, че да се почва!
            </Alert>
            <div class='sm:flex items-start justify-items-start text-xmas-olive'>
                <div class='flex-1'>
                    <div class='mt-5'>
                        <p class='mt-6 sm:mt-1 text-sm self-center bg-xmas-gray rounded-sm p-4 text-white'>Напиши няколко думи за себе си. Можеш да споделиш кои са любимите ти игри или какъв тип игри харесваш. Можеш да споделиш какъв тип игри не харесваш. Всичко, което ще помогне на този, който ти подарява да избере перфектния подарък за теб!</p>
                        <Textarea v-model="form.bio" @blur="v$.form.bio.$touch()" :invalid="v$.form.bio.$error"></Textarea>
                    </div>
                    <p class='bg-xmas-gray text-white rounded-md p-4 mt-4'>Ако не искаш да участваш <span class='text-xmas-red font-bold'>(ЗАЩООО?!?!)</span> просто не потвърждавай профила си и няма лоши чувства :)</p>
                </div>
                <div class='flex-1 my-10 sm:my-4'>
                    <div class='px-1 sm:px-8 text-sm text-xmas-olive'>
                        <div class='text-xmas-red text-xl text-center'>Избери си и по кой от следните начини искаш да се включиш в #ГолямотоРазопаковане!</div> <br />
                        <ul class='space-y-5 list-disc px-5 sm:px-0'>
                            <li>Заповядай на 11ти в студиото ни на <b>Златовръх 51</b>, за да си прекараме супер готино една настолна пред-Коледа и да разопаковаш подаръка си на живо в групата Настолни Игри - България!</li>
                            <li>Запиши видео и реакция на подаръка си сам/а и ни го изпрати на santa@maxshow.bg, за да го излъчим по време на живото предаване на 11ти!</li>
                            <li>Заповядай в студиото ни на <b>Златовръх 51</b> в предварително уговорен час, за да разопаковаш подаръка си заедно с нас пред камерите ни, за да го излъчим по време на живото предаване на 11ти!</li>
                        </ul>
                        <Dropdown class='mt-6' :options="waysToParticipate" v-model="form.bigOpening" @change="v$.form.bigOpening.$touch()"></Dropdown>
                    </div>
                    <div class='pr-2 sm:pr-10'>
                        <button :disabled="v$.$invalid" @click='confirm' class='ml-auto my-16 w-48 h-12 relative rounded-full bg-xmas-red disabled:bg-gray-300 tracking-wider text-white font-mont flex justify-center items-center'>
                            <transition name='fade'>
                                <div class='flex' v-if='! loading'>
                                    Потвърждавам!
                                </div>
                            </transition>
                            <pulse-loader :loading="loading" color="#fff" class='absolute mt-2'></pulse-loader>
                        </button>
                    </div>
                </div>
           
            </div>
        </template>
    </div>
    <Modal @confirm='confirmApplication' :open='askForConfirmation' title='Потвърждавам участие' confirmButton="Потвърждавам">
        С потвърждаване на профила се съгласяваш, че след 1 Декември ще трябва да изпратиш подарък на човека, който ти се е паднал.  <br /><br />
        Ако по някаква причина се окаже, че <strong>НЕ МОЖЕШ</strong> да участваш, моля свържи се незабавно с нас на santa@maxshow.bg
    </Modal>
</template>

<script>
import Dropdown from '@/components/Dropdown'
import Alert from '@/components/Alert'
import Modal from '@/components/Modal'
import Text from '@/components/Text'
import Textarea from '@/components/Textarea'
import buttonStack from '@/components/ButtonStack'
import useVuelidate from '@vuelidate/core' 
import PulseLoader from 'vue-spinner/src/PulseLoader.vue'
import { required } from '@vuelidate/validators'

export default {
    name: 'ConfirmationModule',
    components: {
        Alert,
        Text,
        PulseLoader,
        buttonStack,
        Dropdown,
        Textarea,
        Modal,
    },
    data() {
        return {
            user: {},
            loading: false,
            askForConfirmation: false,
            couriers: {
                1: 'Еконт',
                2: 'Спиди',
            },
            waysToParticipate: [
                {
                    id: '',
                    name: "Участие в #ГолямотоРазопаковане?",
                },
                {
                    id: 'live',
                    name: "Ще дойда на живо",
                },
                {
                    id: 'send_video',
                    name: "Ще изпратя видео",
                },
                {
                    id: 'film',
                    name: "Ще снимам при вас",
                },
                {
                    id: 'no',
                    name: "Няма да участвам",
                },
            ],
            form: {               
                bio: null,
                bigOpening: null,
                
            }
        }
    },
    setup() {
        return { v$: useVuelidate() }
    },
    created() {
        this.getUserData();
        this.$store.dispatch('main/stopLoading')
    },
    methods: {
        confirm() {
            this.loading = true;
            this.askForConfirmation = true;
        },
        async confirmApplication() {
            let response = await axios.post('api/account/confirm', this.form);
            let userResponse = await axios.get('/api/user');
            this.user = userResponse.data;
            this.loading = false;
        },
        async getUserData() {
            this.user = this.$store.getters['auth/authUser'];
            this.form = this.user;
            this.loading = false;
        }
    },
    computed: {
        confirmed() {
            return this.user.confirmed;
        },
    },
    validations: {
        form: {            
            bio: {
                required,
            },
            bigOpening: {
                required,
            }
        }
    }
}
</script>